#pragma	once
#include	<iostream.h>
#include	<stdio.h>
#include	<math.h>

#include	"vector2.h"

//O[oϐ̐錾
double	t_start,t_finish;
Vector	R_start;
Vector	V_start;
double	d_t;//ï߻
FILE	*fxdata;
FILE	*consdata;
FILE	*dconsdata;

int	algorithm;
Vector2	(*algo[3])(Vector2	X);
double	a,e,l;
Vector	E;

//֐̐錾`
//萔̌vZ
void	culculate_cons(){
	
	Vector	Temp;
	double	temp;
	Temp	=		R_start	%	V_start;
	Temp	=		V_start	%	Temp;
	E			=		Temp;
	Temp	=		R_start	/	Abs(	V_start	);
	E			-=	Temp;
	
	e	=	V_start	*	V_start	/	2	-	1	/	Abs(	R_start	);
	
	a	=	-	1	/	2	/	e;
	
	l	=	sqrt(	a	*	(	1	-	Abs(E)	*	Abs(E)	));
	
	cout	<<	"E	"	<<	E	<<	"\n";
	cout	<<	"e	"	<<	e	<<	"\n";
	cout	<<	"a	"	<<	a	<<	"\n";
	cout	<<	"l	"	<<	l	<<	"\n";

	fprintf(	fxdata,	"E	");
	for(	int	i	=	0;	i	<	VLEN;	i++){
		fprintf(	fxdata,	"%f	",	E[i]);
	}
	fprintf(	fxdata,	"\n");
	fprintf(	fxdata,	"e	%f\n",	e);
	fprintf(	fxdata,	"a	%f\n",	a);
	fprintf(	fxdata,	"l	%f\n",	l);
}


//l
Vector2	euler_dX(Vector2	X){
	double	temp;
	Vector2	V;
	V[0]	=	X[1];
	temp	=	Abs(X[0]);
	V[1]	=	X[0]	/	(-temp*temp*temp);
	return	V;
}

Vector2	runge_dX(Vector2	X){
	Vector2	K1,K2,K3,K4;
	Vector2	Temp;
	
	K1	=	euler_dX(	X);
	
	Temp	=		K1;
	Temp	*=	(d_t/2);
	Temp	+=	X;
	K2	=	euler_dX(	Temp);
	K2	*=	2;
	
	Temp	=		K2;
	Temp	*=	(d_t/2);
	Temp	+=	X;
	K3	=	euler_dX(	Temp);
	K3	*=	2;
	
	Temp	=		K3;
	Temp	*=	d_t;
	Temp	+=	X;
	K4	=	euler_dX(	Temp);
	
	Temp	=		K1;
	Temp	+=	K2;
	Temp	+=	K3;
	Temp	+=	K4;
	
	return	(	Temp	)	/6	;
}
Vector2	leapflog_dX(	Vector2	X){

	Vector	Temp0,Temp1,Temp2;
	Vector2	Temp;
	
	
	Temp2	=		X[0];
	Temp2	/=	(	-	Abs(Temp2)	*	Abs(Temp2)	*	Abs(Temp2)	);
	Temp2	*=	0.5*d_t;
	Temp1	=		X[1]	+	Temp2;
	
	Temp2	=		Temp1;
	Temp2	*=	d_t;
	Temp0	=		X[0]	+	Temp2;
	
	Temp2	=		Temp0;
	Temp2	/=	(	-	Abs(Temp2)	*	Abs(Temp2)	*	Abs(Temp2)	);
	Temp2	*=	0.5*d_t;
	Temp1	=		Temp1	+	Temp2;
	Temp	=		Vector2(	Temp0,	Temp1);
	Temp	-=	X;
	Temp	/=	d_t;
	
	return	Temp;	
}

//ϕ
void	integral(){
	Vector2	X(	R_start,	V_start);
	Vector2	Temp2;
	printf(	"t		");
	printf(	"l			");
	printf(	"l			");
	printf(	"\n");

	fprintf(	fxdata,	"t	");
	fprintf(	fxdata,	"l			");
	fprintf(	fxdata,	"l			");
	fprintf(	fxdata,	"\n");
	
	fprintf(	consdata,	"t	");
	fprintf(	consdata,	"E			");
	fprintf(	consdata,	"|E|	");
	fprintf(	consdata,	"e	");
	fprintf(	consdata,	"a	");
	fprintf(	consdata,	"l	");
	fprintf(	consdata,	"\n");

	fprintf(	dconsdata,	"t	");
	fprintf(	dconsdata,	"E			");
	fprintf(	dconsdata,	"|E|	");
	fprintf(	dconsdata,	"e	");
	fprintf(	dconsdata,	"a	");
	fprintf(	dconsdata,	"l	");
	fprintf(	dconsdata,	"\n");

	for(	double	t	=	t_start;	t	<	t_finish	+	d_t	/	2;	t	+=	d_t){

		printf(	"%f	",	t);
		cout	<<	"("	<<	X[0]	<<	")	";
		cout	<<	"("	<<	X[1]	<<	")	";
		printf(	"\n");
	
		fprintf(	fxdata,	"%f	",	t);
		for(	int	i	=	0;	i	<	VLEN;	i++){
			fprintf(	fxdata,	"%f	",	X[0][i]);
		}
		for(	int	i	=	0;	i	<	VLEN;	i++){
			fprintf(	fxdata,	"%f	",	X[1][i]);
		}
		fprintf(	fxdata,	"\n	");
	
		//萔̌vZ
		Vector	Temp;
		double	temp;
		Vector	EE;
		double	ee,aa,ll;
		Temp	=		X[0]	%	X[1];
		Temp	=		X[1]	%	Temp;
		EE			=		Temp;
		Temp	=		X[0]	/	Abs(	X[1]	);
		EE			-=	Temp;
		
		ee	=	X[1]	*	X[1]	/	2	-	1	/	Abs(	X[0]	);
		
		aa	=	-	1	/	2	/	ee;
		
		ll	=	sqrt(	aa	*	(	1	-	Abs(EE)	*	Abs(EE)	));
		
		fprintf(	consdata,	"%f	",	t);
		for(	int	i	=	0;	i	<	VLEN;	i++){
			fprintf(	consdata,	"%f	",	EE[i]);
		}
		fprintf(	consdata,	"%f	",	Abs(EE));
		fprintf(	consdata,	"%f	",	ee);
		fprintf(	consdata,	"%f	",	aa);
		fprintf(	consdata,	"%f	",	ll);
		fprintf(	consdata,	"\n");

		fprintf(	dconsdata,	"%f	",	t);
		for(	int	i	=	0;	i	<	VLEN;	i++){
			fprintf(	dconsdata,	"%f	",	fabs(EE[i]-E[i]));
		}
		fprintf(	dconsdata,	"%f	",	fabs(Abs(EE)-Abs(E)));
		fprintf(	dconsdata,	"%f	",	fabs(ee-e));
		fprintf(	dconsdata,	"%f	",	fabs(aa-a));
		fprintf(	dconsdata,	"%f	",	fabs(ll-l));
		fprintf(	dconsdata,	"\n");
		
		//ϕ
		Temp2	=	algo[algorithm-1](X);
		Temp2	*=	d_t;
		X	+=	Temp2;		
	}
}

void	integral_all(){
	Vector2	X[3];
	for(	int	i=0;	i	<	3;	i++){
		X[i]	=	Vector2(	R_start,	V_start);
	};

	Vector2	Temp2;

	fprintf(	fxdata,	"t	");
	fprintf(	fxdata,	"IC[@						");
	fprintf(	fxdata,	"ÓTIQNb^@						");
	fprintf(	fxdata,	"[vtbO@");
	fprintf(	fxdata,	"\n");

	fprintf(	fxdata,	"	");
	for(	int	i=0;	i<3;	i++){
		fprintf(	fxdata,	"R			");
		fprintf(	fxdata,	"V			");
	}
	fprintf(	fxdata,	"\n");

	fprintf(	consdata,	"t	");
	for(	int	i=0;	i<3;	i++){
		fprintf(	consdata,	"E			");
		fprintf(	consdata,	"|E|	");
		fprintf(	consdata,	"e	");
		fprintf(	consdata,	"a	");
		fprintf(	consdata,	"l	");
	}
	fprintf(	consdata,	"\n");

		fprintf(	dconsdata,	"t	");
	for(	int	i=0;	i<3;	i++){
		fprintf(	dconsdata,	"E			");
		fprintf(	dconsdata,	"|E|	");
		fprintf(	dconsdata,	"e	");
		fprintf(	dconsdata,	"a	");
		fprintf(	dconsdata,	"l	");
	}
	fprintf(	dconsdata,	"\n");

	for(	double	t	=	t_start;	t	<	t_finish	+	d_t	/	2;	t	+=	d_t){

		printf(	"%f	",	t);
		fprintf(	fxdata,	"%f	",	t);
		fprintf(	consdata,	"%f	",	t);
		fprintf(	dconsdata,	"%f	",	t);

		for(	int	i=0;	i	<	3;	i++){
			for(	int	j=0;	j<VLEN;	j++){
				printf(	"%f	",	X[i][0][j]);
			}
			for(	int	j=0;	j<VLEN;	j++){
				printf(	"%f	",	X[i][1][j]);
			}
			for(	int	j=0;	j<VLEN;	j++){
				fprintf(	fxdata,	"%f	",	X[i][0][j]);
			}
			for(	int	j=0;	j<VLEN;	j++){
				fprintf(	fxdata,	"%f	",	X[i][1][j]);
			}
	
			//萔̌vZ
			Vector	Temp;
			double	temp;
			Vector	EE;
			double	ee,aa,ll;
			Temp	=		X[i][0]	%	X[i][1];
			Temp	=		X[i][1]	%	Temp;
			EE			=		Temp;
			Temp	=		X[i][0]	/	Abs(	X[i][1]	);
			EE			-=	Temp;
		
			ee	=	X[i][1]	*	X[i][1]	/	2	-	1	/	Abs(	X[i][0]	);
		
			aa	=	-	1	/	2	/	ee;
		
			ll	=	sqrt(	aa	*	(	1	-	Abs(EE)	*	Abs(EE)	));
		
			for(	int	i	=	0;	i	<	VLEN;	i++){
				fprintf(	consdata,	"%f	",	EE[i]);
			}
			fprintf(	consdata,	"%f	",	Abs(EE));
			fprintf(	consdata,	"%f	",	ee);
			fprintf(	consdata,	"%f	",	aa);
			fprintf(	consdata,	"%f	",	ll);

			for(	int	i	=	0;	i	<	VLEN;	i++){
				fprintf(	dconsdata,	"%f	",	fabs(EE[i]-E[i]));
			}
			fprintf(	dconsdata,	"%f	",	fabs(Abs(EE)-Abs(E)));
			fprintf(	dconsdata,	"%f	",	fabs(ee-e));
			fprintf(	dconsdata,	"%f	",	fabs(aa-a));
			fprintf(	dconsdata,	"%f	",	fabs(ll-l));
	
			Temp2	=	algo[i](X[i]);
			Temp2	*=	d_t;
			X[i]	+=	Temp2;
		}
		printf(	"\n");
		fprintf(	fxdata,	"\n");
		fprintf(	consdata,	"\n");
		fprintf(	dconsdata,	"\n");
	}		
}


//ϕ@̑I
void	select_algorithm(){
	//ϐ錾
	algorithm	=	0;
	char	temp[256];	
	//ϕ@I
	while(	(algorithm	<	1)	|	(4	<	algorithm)	){
		printf("ϕ@IĂB\n");
		printf("@@1FIC[@\n");
		printf("@@2FÓTIQNb^@\n");
		printf("@@3F[vtbO@\n");
		printf("@@4FׂĂ̕@ōs\n");
		printf("ԁHF");
		gets(	temp	);
		algorithm	=	atoi(	temp);
		switch(	algorithm	){
			case	1:
				fprintf(	fxdata,	"IC[@\n");
				fprintf(	consdata,	"IC[@\n");
				fprintf(	dconsdata,	"IC[@\n");
				break;
			case	2:
				fprintf(	fxdata,	"ÓTIQNb^@\n");
				fprintf(	consdata,	"ÓTIQNb^@\n");
				fprintf(	dconsdata,	"ÓTIQNb^@\n");
				break;
			case	3:
				fprintf(	fxdata,	"[vtbO@\n");
				fprintf(	consdata,	"[vtbO@\n");
				fprintf(	dconsdata,	"[vtbO@\n");
				break;
			case	4:
				fprintf(	fxdata,	"ׂĂ̕@\n");
				fprintf(	consdata,	"	IC[@							ÓTIQNb^@							[vtbO\n");
				fprintf(	dconsdata,	"	IC[@							ÓTIQNb^@							[vtbO\n");
			break;
		}
	}
}

//ϕ̐ݒ
void	establishment(){
	//ϐ錾
	char	temp[256];
	
	//ϐ̓
	cout	<<	"l\n";
	fprintf(	fxdata,	"l\n");
	
	cout	<<	"  t : ";
	cin	>>	t_start;
	fprintf(	fxdata,	"t	%f\n",	t_start);
	
	cout	<<	"  R : ";
	cin	>>	R_start;
	fprintf(	fxdata,	"R	");
	for(	int	i=	0;	i	<	VLEN;	i++){
		fprintf(	fxdata,	"%f	",	R_start[i]);
	}
	fprintf(	fxdata,	"\n");

	cout	<<	"  V : ";
	cin	>>	V_start;
	fprintf(	fxdata,	"V	");
	for(	int	i=	0;	i	<	VLEN;	i++){
		fprintf(	fxdata,	"%f	",	V_start[i]);
	}
	fprintf(	fxdata,	"\n");
		
	cout	<<	"Il\n";
	fprintf(	fxdata,	"Il\n");
	
	cout	<<	"  t : ";
	cin	>>	t_finish;
	fprintf(	fxdata,	"t	%f\n",	t_finish);
	
	cout	<<	"XebvTCY\n";
	fprintf(	fxdata,	"XebvTCY\n");
	
	cout	<<	"  h : ";
	cin	>>	d_t;
	fprintf(	fxdata,	"h	%f\n",	d_t);
}